
<div class="container home">
    <div class="row mt-5 justify-content-center">
        <div class="col-sm offset-sm">
            <button type="button" class="btn btn-primary btn-outlined" id="btn-search">Récupérer les nouveaux articles</button>
        </div>
        <div class="form-group col-md-4 row">
            <label for="selectData" class="col-md col-form-label">Type de données</label>
            <select class="form-select col-md" id="selectData" aria-label="Default select example">
                <option value="variants">Variants</option>
                <option value="molecules">Molécules</option>
                <option value="vaccins">Vaccins</option>
            </select>  
        </div>
        <div class="form-group col-md-4 row ">
            <label for="selectGraphique" class="col-md col-form-label ">Type de graphique</label>
            <select class="form-select col-md" id="selectGraphique" aria-label="Default select example">
                <option value="histogramme" selected>Histogramme</option>
                <option value="circulaire">Circulaire</option>
            </select>  
        </div>
    </div>
</div>


<br />
<div class="row mt-5" id="variants-charts"></div>
<div class="row mt-5" id="molecules-charts"></div>
<div class="row mt-5" id="variants-circulaire"></div>
<div class="row mt-5" id="molecules-circulaire"></div>
<div class="row mt-5" id ="vaccins-charts"></div>
<div class="row mt-5" id ="vaccins-circulaire"></div>
</div>

<script>
$('#spinner').hide()

 // Bouton de recherche
 $('#btn-search').on('click', function (e) {
    // Affichage du spinner
    $('#spinner').show();    
    $('#btn-search').html(`
        <span class="spinner-border spinner-border-sm" id="spinner" role="status" aria-hidden="true"></span>
        Récupération des nouveaux articles en cours
    `);

    $.get("{% url 'Fetch' %}", function() {
        // Refresh de la page
        location.reload();
    });
})

function drawHistVariants(my_text,my_name, my_categories ,my_datas){
    $('#variants-charts').highcharts({
        chart: {
             type: 'column'
        },
        title: {
            text: my_text
        },
        xAxis: {
            categories: my_categories
        },
        series: [{
            name: my_name,
            data: my_datas
        }]
    });
}

function drawCamVariants(my_text,my_name,my_categories, my_datas){

        var names = my_categories
        var datas = my_datas;
        var final = []

        for(var i = 0; i < names.length; i++){
            final.push({
                name : names[i],
                y : datas[i]
            })
        }

    $("#variants-circulaire").highcharts({
            chart: {
                type: 'pie'
            },
            title: {
                text: my_text
            },
            tooltip: {
                pointFormat: '{series.name}: <b>{point.percentage:.1f}%</b>'
            },
            plotOptions: {
                pie: {
                        allowPointSelect: true,
                        cursor: 'pointer',
                        dataLabels: {
                            enabled: true,
                            format: '<b>{point.name}</b>: {point.percentage:.1f} %',
                            style: {
                                color: (Highcharts.theme && Highcharts.theme.contrastTextColor) || 'black'
                            }
                        }
                }
            },
            series: [{
                name: my_name,
                data: final
            }]
        })
}

function drawHistMolecules(my_text,my_name, my_categories ,my_datas){
    $('#molecules-charts').highcharts({
        chart: {
             type: 'column'
        },
        title: {
            text: my_text
        },
        xAxis: {
            categories: my_categories
        },
        series: [{
            name: my_name,
            data: my_datas
        }]
    });
}

function drawCamMolecules(my_text,my_name,my_categories, my_datas){
    var names = my_categories
    var datas = my_datas;
    var final = []

    for(var i = 0; i < names.length; i++){
        final.push({
            name : names[i],
            y : datas[i]
        })
    }

    $("#molecules-circulaire").highcharts({
            chart: {
                type: 'pie'
            },
            title: {
                text: my_text
            },
            tooltip: {
                pointFormat: '{series.name}: <b>{point.percentage:.1f}%</b>'
            },
            plotOptions: {
                pie: {
                        allowPointSelect: true,
                        cursor: 'pointer',
                        dataLabels: {
                            enabled: true,
                            format: '<b>{point.name}</b>: {point.percentage:.1f} %',
                            style: {
                                color: (Highcharts.theme && Highcharts.theme.contrastTextColor) || 'black'
                            }
                        }
                }
            },
            series: [{
                name: my_name,
                data: final
            }]
        })
}


function drawHistVaccins(my_text,my_name, my_categories ,my_datas){
    $('#vaccins-charts').highcharts({
        chart: {
             type: 'column'
        },
        title: {
            text: my_text
        },
        xAxis: {
            categories: my_categories
        },
        series: [{
            name: my_name,
            data: my_datas
        }]
    });
}

function drawCamVaccins(my_text,my_name, my_categories ,my_datas){
    var names = my_categories
    var datas = my_datas;
    var final = []

    for(var i = 0; i < names.length; i++){
        final.push({
            name : names[i],
            y : datas[i]
        })
    }

    $("#vaccins-circulaire").highcharts({
            chart: {
                type: 'pie'
            },
            title: {
                text: my_text
            },
            tooltip: {
                pointFormat: '{series.name}: <b>{point.percentage:.1f}%</b>'
            },
            plotOptions: {
                pie: {
                        allowPointSelect: true,
                        cursor: 'pointer',
                        dataLabels: {
                            enabled: true,
                            format: '<b>{point.name}</b>: {point.percentage:.1f} %',
                            style: {
                                color: (Highcharts.theme && Highcharts.theme.contrastTextColor) || 'black'
                            }
                        }
                }
            },
            series: [{
                name: my_name,
                data: final
            }]
        })
}

// affichage par defaut du Graphique Histogramme des variants 
$('#selectData').val("variants");
$('#selectGraphique').val("histogramme");

drawHistVariants('Histogramme des variants', 'Variants', {{variants_cat|safe}}, {{variants_res}});


$('#selectData').change(function(event){
    var type_representation = $('#selectGraphique').val();

    if(event.target.value == "variants" && type_representation == "histogramme"){
        $('#molecules-charts').hide();
        $('#molecules-circulaire').hide();
        $("variants-circulaire").hide();
        $("#vaccins-circulaire").hide();
        $("#vaccins-charts").hide();
        $("#variants-charts").show();

        drawHistVariants('Histogramme des variants', 'Variants',{{variants_cat|safe}}, {{variants_res}});

    }
    else if(event.target.value == "variants" && type_representation == "circulaire"){
        $('#variants-charts').hide();
        $('#molecules-charts').hide();
        $('#molecules-circulaire').hide();
        $("#vaccins-circulaire").hide();
        $("#vaccins-charts").hide();
        $("#variants-circulaire").show();

        drawCamVariants('circulaire des variants','Total', {{ variants_cat|safe }}, {{ variants_res }});
    }
    else if(event.target.value == "molecules" && type_representation == "histogramme"){

        console.log({{ molecules_res }})
        console.log({{ molecules_cat|safe }})

        $("#variants-circulaire").hide();
        $("#variants-charts").hide();
        $('#molecules-circulaire').hide();
        $("#vaccins-circulaire").hide();
        $("#vaccins-charts").hide();
        $('#molecules-charts').show();
        
        drawHistMolecules('Histogramme des molécules', 'Molécules',{{ molecules_cat|safe }}, {{ molecules_res }});
    }
    else if(event.target.value == "molecules" && type_representation == "circulaire"){
        $("#variants-circulaire").hide();
        $("#variants-charts").hide();
        $('#molecules-charts').hide();
        $("#vaccins-circulaire").hide();
        $("#vaccins-charts").hide();
        $('#molecules-circulaire').show();

        drawCamMolecules("Diagramme circulaire des molécules", 'Molécules', {{ molecules_cat|safe }}, {{ molecules_res }});
    }
    else if(event.target.value == "vaccins" && type_representation == "histogramme"){
        $("#variants-circulaire").hide();
        $("#variants-charts").hide();
        $('#molecules-charts').hide();
        $('#molecules-circulaire').hide();
        $("#vaccins-circulaire").hide();
        $("#vaccins-charts").show();

        drawHistVaccins("Histogramme des vaccins", 'Vaccins', {{ vaccins_cat | safe}}, {{ vaccins_res }});
    }

    else if(event.target.value == "vaccins" && type_representation == "circulaire"){
        $("#variants-circulaire").hide();
        $("#variants-charts").hide();
        $('#molecules-charts').hide();
        $('#molecules-circulaire').hide();
        $("#vaccins-charts").hide();
        $("#vaccins-circulaire").show();

        drawCamVaccins("Diagramme circulaire des vaccins", 'Vaccins', {{ vaccins_cat | safe}}, {{ vaccins_res }});
    }
})

$('#selectGraphique').change(function(event){   //gestion d'affichage selon le changement du type de graphique
    var type_data = $('#selectData').val();

    if(event.target.value == "circulaire" && type_data == "variants"){
        $('#variants-charts').hide();
        $('#molecules-charts').hide();
        $('#molecules-circulaire').hide();
        $("#vaccins-circulaire").hide();
        $("#vaccins-charts").hide();
        $("#variants-circulaire").show();

        drawCamVariants('Diagramme circulaire des variants','Variants', {{ variants_cat | safe }}, {{ variants_res }});
    }
    else if(event.target.value == "circulaire" && type_data == "molecules"){
        $('#variants-charts').hide();
        $('#molecules-charts').hide();
        $('#variants-circulaire').hide();
        $("#vaccins-circulaire").hide();
        $("#vaccins-charts").hide();
        $("#molecules-circulaire").show();

        drawCamMolecules("Diagramme circulaire des Molécules", 'Molécules', {{molecules_cat|safe}}, {{molecules_res}});
    }
    else if(event.target.value == "histogramme" && type_data == "variants"){
        $('#molecules-charts').hide();
        $("#molecules-circulaire").hide();
        $('#variants-circulaire').hide();
        $("#vaccins-circulaire").hide();
        $("#vaccins-charts").hide();
        $("#variants-charts").show();

        drawHistVariants('Histogramme des variants', 'Variants',{{variants_cat|safe}}, {{variants_res}});
    }
    else if(event.target.value == "histogramme" && type_data == "molecules"){
        $("#variants-charts").hide();
        $("#variants-circulaire").hide();
        $("#molecules-circulaire").hide();
        $("#vaccins-circulaire").hide();
        $("#vaccins-histogramme").hide();
        $('#molecules-charts').show();
        
        drawHistMolecules('Histogramme des molecules', 'Molécules',{{molecules_cat|safe}}, {{molecules_res}});
    }
    else if(event.target.value == "histogramme" && type_data == "vaccins"){
        $("#variants-charts").hide();
        $("#variants-circulaire").hide();
        $("#molecules-circulaire").hide();
        $('#molecules-charts').hide();
        $("#vaccins-circulaire").hide();
        $("#vaccins-charts").show();
     
        drawHistVaccins('Histogramme des Vaccins','Vaccins', {{ vaccins_cat | safe}}, {{ vaccins_res }});
    }
    else if(event.target.value == "circulaire" && type_data == "vaccins"){
        $("#variants-charts").hide();
        $("#variants-circulaire").hide();
        $("#molecules-circulaire").hide();
        $('#molecules-charts').hide();
        $("#vaccins-circulaire").show();
        $("#vaccins-charts").hide();
        
        drawCamVaccins('Diagramme circulaire des vaccins','Vaccins', {{ vaccins_cat | safe}}, {{ vaccins_res }});
    }
})
</script>